SystemOrganization addCategory: #Cooliris!

!WARenderCanvas methodsFor: '*Cooliris' stamp: 'SR 08/22/2009 14:26'!
cooliris
	^ self brush: Cooliris new! !

SWFObject2 subclass: #Cooliris
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cooliris'!

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:47'!
backgroundAlpha: aFloat
	" Changes background transparency (Not Well Supported on IE). "
	self variableAt: #backgroundAlpha put: ((aFloat asFloat max: 0.0) min: 1.0).
	self beTransparent! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:49'!
backgroundColorHex: aHexString
	" Sets a color for the background "
	self variableAt: #backgroundColor put: aHexString! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:43'!
backgroundImage: aStringOrUrl
	" Specifies a background image for the wall.
	The background image can be a PNG, GIF, or JPG. The background image covers the background color. "
	self variableAt: #backgroundImage put: aStringOrUrl asString! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:59'!
beBlack
	self style: 'black'! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:59'!
beDark
	self style: 'dark'! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:59'!
beLight
	self style: 'light'! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:59'!
beWhite
	self style: 'white'! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 15:04'!
customButtonUrl: aStringOrUrl targetUrl: aStringOrUrl2
	" Adds a custom button in the lower right corner of the toolbar.  "
	self variableAt: #customButton put: aStringOrUrl asString, ',', aStringOrUrl2 asString! !

!Cooliris methodsFor: 'accessing-defaults' stamp: 'SR 08/22/2009 15:21'!
defaultFlashUrl
	^ 'http://apps.cooliris.com/embed/cooliris.swf'! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:43'!
descriptionHeight: anInteger
	" Sets the percentage height of the name and description overlay when items are selected.  "
	self variableAt: #descriptionHeight put: ((anInteger max: 0) min: 100)! !

!Cooliris methodsFor: 'config-media' stamp: 'SR 08/22/2009 16:34'!
feedUrl: anUrl
	" MediaRSS e.g. www.mydomain.com/photos.rss 
	  Flickr e.g. api://www.flickr.com/...
	  Picasa e.g. api://picasaweb.google.com/... 
	  for more infos see: http://developer.cooliris.com/?p=embed/display 
	  NOTICE: RLS in any feed should be absolute - relative urls will not always work !!!!!! "
	self variableAt: #feed put: anUrl! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:48'!
glowColor: aColor
	self glowColorHex: aColor asHTMLColor ! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:49'!
glowColorHex: aHexString
	" Changes the color of the glow around the selected cell (Default is white). "
	self variableAt: #glowColor put: aHexString! !

!Cooliris methodsFor: 'config-media' stamp: 'SR 08/22/2009 14:51'!
iconsUrl: aStringOrUrl
	" Points to a directory of PNG images for custom toolbar icons.
The following filenames in the directory will be used:

    * embed.png - Embed Code button
    * fullscreen.png - Fullscreen/Launch Client button
    * next.png - Next Item button
    * pause.png - Pause Slideshow button
    * play.png - Start Slideshow button.
    * prev.png - Previous Item button
    * search.png - Search button "
	self variableAt: 'icons' put: aStringOrUrl asString! !

!Cooliris methodsFor: 'initialization' stamp: 'SR 08/22/2009 22:55'!
initialize
	super initialize.
	self enableScriptAccess.
	self fullscreen: true.! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 15:01'!
linkCss: aString
	" A CSS string to be applied to any HTML links in item descriptions.  "
	self variableAt: #linkCSS put: aString! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 15:51'!
reflections: aBlockOrBoolean
	" Shows or hides the reflections under the images.
Hiding the reflections will improve performance. "
	self variableAt: 'showReflections' put: aBlockOrBoolean value! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 15:48'!
rows: anInteger
	" Sets how many rows of images to show in the UI.
Note that as you show more rows, the wall is more CPU intensive and may run slower for older computers.  "
	self variableAt: #numRows put: ((anInteger max: 0) min: 7)! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 15:52'!
showAllButtons
	self showChrome: true;
		showDescription: true;
		showEmbed: true;
		showSearch: true;
		showTutorial: true! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:53'!
showChrome: aBlockOrBoolean
	" Shows or hides the bottom toolbar background. "
	self variableAt: 'showChrome' put: aBlockOrBoolean value! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:53'!
showDescription: aBlockOrBoolean
	" Shows or hides the item description overlay.  "
	self variableAt: 'showDescription' put: aBlockOrBoolean value! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:53'!
showEmbed: aBlockOrBoolean
	" Shows or hides the Embed Code button.  "
	self variableAt: 'showEmbed' put: aBlockOrBoolean value! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:55'!
showNavArrows: aBlockOrBoolean
	" Shows or hides the left/right navigation arrows.  "
	self variableAt: #showNavArrows put: aBlockOrBoolean value! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 15:52'!
showNoButtons
	self showChrome: false;
		showDescription: false;
		showEmbed: false;
		showSearch: false;
		showTutorial: false! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:54'!
showSearch: aBlockOrBoolean
	" Shows or hides the Search button. "
	self variableAt: 'showSearch' put: aBlockOrBoolean value! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:54'!
showTutorial: aBlockOrBoolean
	" If set to true, show a tutorial message if the user does not click on the wall.
By default, the tutorial message says Click and Drag to Begin, and will display after a few seconds of no interaction. This can be customized with the tutorial FlashVar.  "
	self variableAt: 'showTutorial' put: aBlockOrBoolean value! !

!Cooliris methodsFor: 'config-media' stamp: 'SR 08/22/2009 15:02'!
startAt: aString
	" Sets the initially-selected item when the wall loads.
The wall will automatically select the item in a MediaRSS feed with the <guid> </guid> that matches the provided identifier. This enables you to provide permalinks to a particular item in the wall. Note that the desired item must be present in the initial feed loaded by the wall (it can't be in a next/previous feed).  "
	self variableAt: #itemGUID put: aString! !

!Cooliris methodsFor: 'private' stamp: 'SR 08/22/2009 14:59'!
style: aString
	" Sets the theme to use for the wall.
This sets up different default background colors and button appearances. "
	self variableAt: #style put: aString! !

!Cooliris methodsFor: 'config-visibility' stamp: 'SR 08/22/2009 14:56'!
tilt: anInteger
	" Sets the amount of wall tilt (or disables it by setting it to 0). "
	self variableAt: #tilt put: ((anInteger max: 0) min: 5)! !

!Cooliris methodsFor: 'config-media' stamp: 'SR 08/22/2009 14:58'!
tutorialUrl: aStringOrUrl after: millliseconds
	" Customizes the tutoril message and delay.
Instead of the simple Click & Drag to Begin, you can use your own tutorial message (as an image file). To customize the delay and tutorial, pass in a time value (in milliseconds) and a URL to your tutorial image. For example, tutorial=4500,images/tutorial.png will show the designed PNG in 4.5 seonds, unless the user starts interacting with the wall. "
	self variableAt: #tutorial put: millliseconds asString, ',', aStringOrUrl asString! !

WAEntryPoint subclass: #CoolirisEntryPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cooliris'!

!CoolirisEntryPoint commentStamp: 'SR 08/22/2009 15:44' prior: 0!
This probably required a little rewrite for your Apache. Here's a simple example

# swf
RewriteRule ^/seaside/myapplication/crossdomain.xml(.*)$ 	http://localhost:8080/seaside/cooliris-embedded-wall$1 [P,L]
RewriteRule ^/crossdomain.xml(.*)$ 							http://localhost:8080/seaside/cooliris-embedded-wall$1 [P,L]!

!CoolirisEntryPoint class methodsFor: 'installation' stamp: 'SR 08/22/2009 15:37'!
register
	WADispatcher default register: self new! !

!CoolirisEntryPoint class methodsFor: 'installation' stamp: 'SR 08/22/2009 15:37'!
unregister
	WADispatcher default unregister: self new! !

!CoolirisEntryPoint methodsFor: 'accessing-defaults' stamp: 'SR 08/22/2009 15:43'!
defaultName
	^ 'cooliris-embedded-wall'! !

!CoolirisEntryPoint methodsFor: 'private' stamp: 'SR 08/22/2009 15:33'!
documentFor: aRequest
	^ '<?xml version="1.0"?><!!DOCTYPE cross-domain-policy SYSTEM "http://www.macromedia.com/xml/dtds/cross-domain-policy.dtd"><cross-domain-policy><allow-access-from domain="*.cooliris.com" secure="false" /></cross-domain-policy>'! !

!CoolirisEntryPoint methodsFor: 'processing' stamp: 'SR 08/22/2009 15:39'!
handleRequest: aRequest
	^ WAResponse
		document: (self documentFor: aRequest)
		mimeType: 'text/xml'
		fileName: self defaultName! !

!CoolirisEntryPoint methodsFor: 'initialization' stamp: 'SR 08/22/2009 15:39'!
initialize
	super initialize.
	self setName: self defaultName! !
